
{$APPTYPE GUI}{$MODE DELPHI}

program demo37;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Collision,GOGL_3DS;

//const
 
type
  TerrainCharacterTable = array[0..99,0..99]of char;
  
var 
  TerrainTable: TerrainCharacterTable = 
   ('.......................................111111111....................................................',
	'...................................111133443333311..................................................',
	'.................................113333222222222341.................................................',
	'................................1332222210--01122231................................................',
	'................................14211000-----00122311...............................................',
	'................................133211000-----0011131...............................................',	
	'................................133211000-----0011131...............................................',	
	'................................133211000-----0011131...............................................',
	'.................................1132221100--02223331...............................................',
	'...................................13343332222343111................................................',
    '....................................1111113333111...................................................',
    '..........................................1111......................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................', 
    '....................................................................................................',
    '....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'...........................................................................111......................',
	'.........................................................................112321.....................', 
    '...........................................................................111......................',
    '....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................', 
    '....................................................................................................',
    '....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................', 
    '....................................................................................................',
    '....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'...............................111..................................................................',
	'.......................................22222........................................................',
	'..............................000000..2234332.......................................................',
	'.............................00---000.2234432.......................................................', 
    '.............................00--00....22222........................................................',
    '....................................................................................................',
	'....................................................................................................',
	'...........................-........................................................................',
	'..........................-=-.......................................................................',
	'.........................-=-........................................................................',
	'.......................-==-.........................................................................',
	'................------==--..........................................................................',
	'...........-----======--............................................................................',
	'......-----=====------====--........................................................................', 
    '------=====-----......----==---.....................................................................',
    '======-----...............--===----.................................................................',
	'------......................---====------...........................................................',
	'...............................----=====--..........................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'..............................................................111111................................',
	'..........................................................111122222111111111........................',
	'...............................................222111111212222333333333322221111....................', 
    '.................000..........................122223333333344455555543333333222211..................',
    '..............00000000......................112222223345554555666666555444555432221.................',
	'..........0000-----0000....................11222233456666777776567777666666555543221................',
	'.........00----===---000.....................122223345566666667777766557776665542221................',
	'.........0--=====-==--000......................1111222233345556666776677677665543222................',
	'........0-=====--===--000..........................1.1.11112234455666777766655432222................',
	'........0---====--===-00...................................122234455566666555432111.................',
	'.........0000---====--0.....................................11222344555544443321....................',
	'.............0000-----00......................................11112223333222222.....................',
	'.................0--==--000.......................................1111111111........................', 
    '..................00----000000......................................................................',
    '....................0000....000000..................................................................',
	'...............................000000...............................................................',
	'..................................0000000000000000000000000.........................................',
	'.....................................0000000000000000000000000......................................',
	'............................................................00000...................................',
	'................................................................000.................................',
	'..................................................................000...............................',
	'....................................................................00..............................',
	'....................................................................00..............................'); 

	
  ElementTable: TerrainCharacterTable = 
   ('....................................................................................................',
    '....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'.....................................C..............................................................',
	'....................................................................................................',
	'..........................................CC.....C..................................................',
	'..............................C....a................................................................',
	'.....................................AAA.....a..a......C............................................',
    '............................C.......C...............................................................',
    '................................A......A....A..C..AA.A..............................................',
	'.................................A......C........A.A..A.............................................',
	'............................a......C.......A.....A..A...............................................',
	'................................C.....a........C....................................................',
	'...........................................C........................................................',
	'....................................................................................................',
	'....................................................................................................',
	'........................................................................a...........................',
	'...........................................................................C........................', 
    '.............a.....C.................................................a..............................',
    '........C.............................................C.................A...........................',
	'............a...A...................................................................................',
	'.......C.C..........................................C.......C.......................................',
	'.............a........................C.............................................................',
	'....................................................................................................',
	'.................................C......aa.a.a.........C............................................',
	'....................................C.......C.......................................................',
	'....................................................................................................',
	'................................C.........C.........................................................', 
    '....................................................................................................',
    '..............C.....................................................................................',
	'............................................................C.......................................',
	'..........................................C....C....................................................',
	'...................................C............................C...................................',
	'............................C.........C....AAA.....A...C............................................',
	'..............................................A.....A...............................................',
	'..............................a...A.....A....A...A....C...A.........................................',
	'..........................................................A..........a..............................',
	'.......................C.......C.......C...A...A......A.............................................', 
    '...................................A...............A.....C..........................................',
    '.......................................C...A......A.....C.............................C.............',
	'..........................C.........C....C...........A.........................C...C....C...........',
	'..............................................C...................................C.................',
	'.................................C.............................................C......C..C..........',
	'..........................................C.................a......................C................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................', 
    '..............C.....C...............................................................................',
    '....................................................................................................',
	'..........C.....a..a...C............................................................................',
	'.............A..........C...........................................................................',
	'..................a.................................................................................',
	'..........C..........C...................C.............A..A.........................................',
	'...............C.................C...a.........A...A........A.......................................',
	'............................................C..........A.a..........................................',
	'.............................C....A.....A........A...a..A..A...C....................................',
	'.........................A...........................AA.............................................', 
    '................................A....A..A....A... ..........a.......................................',
    '........................a...A.A............C...........a.....a.........C............................',
	'........................a..........A...AA.......A...C.....a.........................................',
	'................................A....A......A................C......................................',
	'........................C...A..AA..A.....Aa......A..................................................',
	'..............................A....A..A....A...C....................................................',
	'............................C....A.......A..........................................................',
	'.....................................C.......C.................C....................................',
	'....................................................................................................',
	'....................................................................................................', 
    '....................................................................................................',
    '....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................', 
    '....................................................................................................',
    '....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................', 
    '....................................................................................................',
    '....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................',
	'....................................................................................................'); 		
 
  i,l:integer; 
  albero,albero1:array[0..9]of gluint; 
  AlbSize,AlbRot:array[0..99,0..99]of glfloat;
  AlbSel:array[0..99,0..99]of integer; 
  ErbaPos:array[0..99,0..99]of glfloat;
  
  CamRot:TGLVector;
  camera:TGLVector;
  MuoviCamera:glfloat = 2.5;
  altitudine:glfloat = 25;
   
  MdlRot:TGLVector;
  aereo:TGL3DSModel; 
   
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tu,tv:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1*tu,-1*tv, 0,-1*tv, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1*tu,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end;


procedure TexAlbero;
begin
  TextureSelectID(1);
end;
 
 
procedure TexFoglie;
begin
  TextureTGASelectID(0);
end;
 
 
procedure Chioma;
begin
  glDisable(GL_CULL_FACE);
  Quad(-0.35,0,-0.35, 0.35,0,-0.35, -0.35,0,0.35*2, 0.35,0,0.35*2, 1,1);
  glEnable(GL_CULL_FACE);  
end; 
 
 
procedure TexAlbero1;
begin
  TextureSelectID(2);
end;
 
 
procedure TexFoglie1;
begin
  TextureTGASelectID(1);
end; 
 
 
procedure Chioma1;
begin
  glDisable(GL_CULL_FACE);
  glPushMatrix;
  glScalef(1+AlbSize[0,0],1+AlbSize[0,0],1+AlbSize[0,0]);    
  Quad(-1,0,-1, 1,0,-1, -1,0,1, 1,0,1, 1,1);
  glPopMatrix;
  glEnable(GL_CULL_FACE);  
end;


procedure TileWater(x,y,z,width,depth,h,tsize:glfloat;RepeatTexture:boolean);
var
  tu,tv:glfloat;
begin
  if RepeatTexture then begin tu:=1*(tsize/2)*width/2; tv:=1*(tsize/2)*depth/2 end 
  else begin tu:=(1/2)*width/tsize; tv:=(1/2)*depth/tsize;end; 
 
  glPushMatrix;	
  glTranslatef(x,y,z);  
  glEnable(GL_BLEND);
  SetglSprite(0.3);    
  Quad(-width,h+1/5,-depth, width,h+1/5,-depth, -width,h+1/5,depth, width,h+1/5,depth, tu,tv);   // inferiore  
  SetglSpriteOFF;
  glDisable(GL_BLEND);  
  glPopMatrix;   
end;


procedure GenTerrain(min,max,step:integer;radius:glfloat;TerrainTable,ElementTable:TerrainCharacterTable);
var
  i,l,count:integer;
  map:array[0..100,0..100]of glfloat; 
begin
  my:=glvertex(camera.x,camera.y-50+altitudine,camera.z);
  
  count:=(max-min)div step;
  
  // altezze terreno
  for i:=0 to count do
  begin
    for l:=0 to count do
    begin
      case TerrainTable[l,i]of
	    '=': map[i,l]:=-2*3; 
	    '-': map[i,l]:=-2*2; 		
	    '0': map[i,l]:=-2;
	    '.': map[i,l]:=0;        		 
	    '1': map[i,l]:=2;
	    '2': map[i,l]:=2*2;  
	    '3': map[i,l]:=2*3; 
	    '4': map[i,l]:=2*4;
	    '5': map[i,l]:=2*5;
	    '6': map[i,l]:=2*6;
        '7': map[i,l]:=2*7;		
      end;	
    end;
  end;    

  // terreno
  TwoSideON;
  glDisable(GL_CULL_FACE); 
  
  glPushMatrix;
  glBegin(GL_QUADS);
  for i:=0 to count-1 do
  begin
	for l:=0 to count-1 do
	begin  
	  //if PointInsideCylinder(glvector(min+i*step,0,min+l*step),glvector(my.x,my.y,my.z),radius,200)then
	  begin
        FindNormal(min+i*step,map[i,l]*2,min+l*step, min+(i+1)*step,map[i+1,l]*2,min+l*step, min+(i+1)*step,map[i+1,l+1]*2,min+(l+1)*step);
        glNormal3f(FNormal[1], FNormal[2], FNormal[3]);		
	    LineFree(step/3,step/3, 0,step/3, 
	             min+i*step,map[i,l]*2,min+l*step, min+(i+1)*step,map[i+1,l]*2,min+l*step,true);
	    LineFree(0,0, step/3,0, 
	             min+(i+1)*step,map[i+1,l+1]*2,min+(l+1)*step, min+i*step,map[i,l+1]*2,min+(l+1)*step,true);
      end;			   
	end;
  end;
  glEnd;
  glPopMatrix;
  
  glEnable(GL_CULL_FACE);
  TwoSideOFF;

  for i:=0 to count-1 do
  begin
    for l:=0 to count-1 do
    begin
	  // alberi vicini
	  if PointInsideCylinder(glvector(min+i*step,0,min+l*step),glvector(my.x,my.y,my.z),radius/2.5,200)then
	  begin	
        case ElementTable[l,i]of 
	    'A': begin 
	          glPushMatrix;
	          glTranslatef(min+i*step,map[i,l]*2+0.7+(0.5+AlbSize[i,l]),min+l*step);		
		      glRotatef(AlbRot[i,l],0,1,0);
			  glScalef(1.5+AlbSize[i,l],1.5+AlbSize[i,l],1.5+AlbSize[i,l]);
			  glCallList(albero[AlbSel[i,l]]);
			  glPopMatrix; 
			 end; 		
	    'a': begin 
	          glPushMatrix;
	          glTranslatef(min+i*step,map[i,l]*2+0.7+(0.8+AlbSize[i,l]),min+l*step);		
		      glRotatef(AlbRot[i,l],0,1,0);
			  glScalef(1.8+AlbSize[i,l],1.8+AlbSize[i,l],1.8+AlbSize[i,l]);
			  glCallList(albero1[AlbSel[i,l]]);
			  glPopMatrix; 		
		     end;		 
        end;
      end;		  

	  // alberi lontani	   
	  if TubeTriangleCollision(glvector(min+i*step,0,min+l*step),glvector(my.x,my.y,my.z),radius/2.5,radius,200)then
	  begin	
        case ElementTable[l,i]of 
	    'A': begin 
	          glPushMatrix;
              BillboardBegin(min+i*step,map[i,l]*2-0.3,min+l*step);				 
			  glScalef(1.5+AlbSize[i,l],1.5+AlbSize[i,l],1.5+AlbSize[i,l]);
			  TextureTGASelectID(3);
			  SetglSprite; 
			  Quad(-2,0,0, 2,0,0, -2,2*2,0, 2,2*2,0, 1,1);
			  SetglSpriteOFF;
              BillboardEnd; 			  
			  glPopMatrix; 
			 end; 		
	    'a': begin 
	          glPushMatrix;
              BillboardBegin(min+i*step,map[i,l]*2-0.3,min+l*step);					 
			  glScalef(1.8+AlbSize[i,l],1.8+AlbSize[i,l],1.8+AlbSize[i,l]);
			  TextureTGASelectID(4);
			  SetglSprite; 
			  Quad(-2,0,0, 2,0,0, -2,2*2,0, 2,2*2,0, 1,1);
			  SetglSpriteOFF; 
			  BillboardEnd; 	
			  glPopMatrix; 		
		     end;	 
        end;	
      end;		  
		  
	  // erba e cespugli  
	  if PointInsideCylinder(glvector(min+i*step,0,min+l*step),glvector(my.x,my.y,my.z),radius,200)then
	  begin  
		if((ErbaPos[i,0]>10)and(ErbaPos[i,0]<50))and((ErbaPos[0,l]>10)and(ErbaPos[0,l]<50))then 
		begin		  
		  TextureTGASelectID(2);
	      SetglSprite;
	      glPushMatrix;	
		  BillboardBegin(min+i*step,map[i,l]*2,min+l*step);
		  glScalef(1+AlbSize[i,l],1+AlbSize[i,l],1+AlbSize[i,l]);
	  	  Quad(-0.35,0,0, 0.35,0,0, -0.35,0.35*2,0, 0.35,0.35*2,0, 1,1);
		  Quad(-0.35+0.15,0,0-0.25, 0.35+0.15,0,0+0.25, -0.35+0.15,0.35*2.5,0-0.25, 0.35+0.15,0.35*2.5,0+0.25, 1,1);
	      BillboardEnd;
		  glPopMatrix; 	
          SetglSpriteOFF;	
        end;
		
        case ElementTable[l,i]of 
	    'C': begin 
	          glPushMatrix;
              BillboardBegin(min+i*step,map[i,l]*2,min+l*step);					 
			  glScalef(1.8+AlbSize[i,l],1.8+AlbSize[i,l],1.8+AlbSize[i,l]);
			  TextureTGASelectID(1);
			  SetglSprite; 
			  Quad(-0.5,0,0, 0.5,0,0, -0.5,0.5*2,0, 0.5,0.5*2,0, 1,1);
			  SetglSpriteOFF; 
			  BillboardEnd; 	
			  glPopMatrix; 		
		     end;	 
        end;			
	  end;	
    end;
  end;       
end; 


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('Floor09.bmp',0);
  
  TextureLoadID('corteccia00.bmp',1);
  TextureLoadTGAID('pino.tga',0);
  
  TextureLoadID('corteccia01.bmp',2);
  TextureLoadTGAID('cespuglio.tga',1);  
  
  TextureLoadTGAID('erba00.tga',2);   
  
  TextureLoadTGAID('albero00.tga',3); 
  TextureLoadTGAID('albero01.tga',4);   
  
  TextureLoadID('water4.bmp',3);  
  
  TextureLoadID('bussola.bmp',4);  
  
end;
begin 

  OpenGL_Texture();
  
  //Alberi di tipo 1
  TreeFractal3D(albero[0],Chioma,TexAlbero,TexFoglie,5,3);
  TreeFractal3D(albero[1],Chioma,TexAlbero,TexFoglie,5,3);
  TreeFractal3D(albero[2],Chioma,TexAlbero,TexFoglie,5,3);
  TreeFractal3D(albero[3],Chioma,TexAlbero,TexFoglie,5,3);
  TreeFractal3D(albero[4],Chioma,TexAlbero,TexFoglie,5,3);
  TreeFractal3D(albero[5],Chioma,TexAlbero,TexFoglie,5,3);
  TreeFractal3D(albero[6],Chioma,TexAlbero,TexFoglie,5,3); 
  TreeFractal3D(albero[7],Chioma,TexAlbero,TexFoglie,5,3);
  TreeFractal3D(albero[8],Chioma,TexAlbero,TexFoglie,5,3);
  TreeFractal3D(albero[9],Chioma,TexAlbero,TexFoglie,5,3);

  //Alberi di tipo 2
  TreeFractal3D(albero1[0],Chioma1,TexAlbero1,TexFoglie1,5,3);
  TreeFractal3D(albero1[1],Chioma1,TexAlbero1,TexFoglie1,5,3);
  TreeFractal3D(albero1[2],Chioma1,TexAlbero1,TexFoglie1,5,3);
  TreeFractal3D(albero1[3],Chioma1,TexAlbero1,TexFoglie1,5,3);
  TreeFractal3D(albero1[4],Chioma1,TexAlbero1,TexFoglie1,5,3);
  TreeFractal3D(albero1[5],Chioma1,TexAlbero1,TexFoglie1,5,3);
  TreeFractal3D(albero1[6],Chioma1,TexAlbero1,TexFoglie1,5,3); 
  TreeFractal3D(albero1[7],Chioma1,TexAlbero1,TexFoglie1,5,3);
  TreeFractal3D(albero1[8],Chioma1,TexAlbero1,TexFoglie1,5,3);
  TreeFractal3D(albero1[9],Chioma1,TexAlbero1,TexFoglie1,5,3);
  
  for i:=0 to 99 do for l:=0 to 99 do 
  begin
    AlbSize[i,l]:=AlbSize[i,l]+(1.5-randomf(1.5));
    AlbRot[i,l]:=AlbRot[i,l]+(180-random(360));	
	AlbSel[i,l]:=AlbSel[i,l]+(9-random(9));
	ErbaPos[i,l]:=ErbaPos[i,l]+random(99);
  end;
  
  aereo.LoadModel3DS(0.1,'747.3ds');
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  glDisable(GL_LIGHTING);  
  
  // bussola
  TextureSelectID(4);
  glColor3f(1,1,1);    
  SetglSprite;   
  glPushMatrix;   
  glTranslatef(-1.6,-1.15,0);  
  glRotatef(CamRot.y,0,0,1);  
  Quad(-0.2,-0.2,0, 0.2,-0.2,0, -0.2,0.2,0, 0.2,0.2,0, 1,1);
  glPopMatrix; 
  SetglSpriteOFF; 
  
  // posozione areo
  TextureOFF;  
  glPushMatrix;   
  glTranslatef(-1,-1.15,0); 
  glRotatef(CamRot.x,1,0,0);
  glRotatef(-MdlRot.y*2.5,0,0,1);    
  Quad(-0.2,-0.01,-0.2, 0.2,-0.01,-0.2, -0.2,0.01,-0.2, 0.2,0.01,-0.2, 1,1);  
  glColor3f(0,0,0); 
  Quad(-0.1,-0.01,0.2, 0.1,-0.01,0.2, -0.1,0.01,0.2, 0.1,0.01,0.2, 1,1);
  glPopMatrix;
  TextureON;
  
  glEnable(GL_LIGHTING);    
  
  OpenGL_Init(150,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(0,1,0,0); 
    
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 	
	
  GetCursorPos(mpos);
  SetCursorPos(mpos.x,mpos.y);
  CamRot.y:=CamRot.y+(mpos.x-width div 2)/200;
  CamRot.x:=CamRot.x+(mpos.y-height div 2)/200;
  if CamRot.x>60 then CamRot.x:=60;
  if CamRot.x<-60 then CamRot.x:=-60;  
  
  camera.x:=camera.x+MuoviCamera*sin(DegToRad(CamRot.y))*cos(DegToRad(CamRot.x));
  camera.y:=camera.y+MuoviCamera*sin(DegToRad(CamRot.x));
  camera.z:=camera.z-MuoviCamera*cos(DegToRad(CamRot.y))*cos(DegToRad(CamRot.x));  
  SetFlyCamera(camera.x,camera.y+altitudine,camera.z,CamRot.y,CamRot.x);
  
  if CamRot.x<0 then camera.y:=camera.y+0.06*CamRot.x;
  
  if LeftMouseDown then MuoviCamera:=MuoviCamera+0.05; 
  if RightMouseDown then MuoviCamera:=MuoviCamera-0.05;

  SetglFog(0,0, 0.006, 119*1.5/255,147*1.5/255,1*1.5,GL_EXP2);
  
  TextureSelectID(0);  
  GenTerrain(-399,399,8,80,TerrainTable,ElementTable);
  
  TextureSelectID(3); 
  TileWater(-115,0,292.5, 280,100, -1, 1,true); 
  
  MdlRot:=glvector((height/2-mpos.y)/90,(mpos.x-width/2)/45,0);
  
  TextureOFF;  
  glPushMatrix;   
  glTranslatef(camera.x,camera.y+altitudine-5,camera.z); 
  glRotatef(-CamRot.y-MdlRot.y/4,0,1,0);
  glRotatef(CamRot.x-MdlRot.x,1,0,0);  
  glRotatef(-MdlRot.y*2.5,0,0,1);  
  glRotatef(180,0,1,0);   
  aereo.PutModel3DS;
  glPopMatrix;
  TextureON;
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Simulatore di volo demo ', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(150,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
